! function (windowz, n) {
    n(windowz, !0)
}(window, function (windowz, open) {
    function call(apiName, params, callBack) {
        windowz.zfJSBridge ? windowz.zfJSBridge.call(apiName, checkParams(params), function (ret) {
            callBack._complete && callBack._complete(ret) || delete callBack._complete

            var errCode = ret && ret['errCode']
            switch (errCode) {
                case 0:
                    callBack.success && callBack.success(ret)
                    break
                case 1:
                    callBack.cancel && callBack.cancel(ret)
                    break
                default:
                    callBack.fail && callBack.fail(ret)
                    break
            }
            callBack.complete && callBack.complete(ret)
        }) : defCall(apiName, callBack)
    }

    function checkParams(params) {
        return params || {}
    }

    function defCall(apiName, callBack) {
        if (typeof callBack.fail == 'function') {
            const err = {
                errCode: -1,
                errMsg: "zfJSBridge not found"
              };
            callBack.fail(err)
            callBack.complete && callBack.complete()
        }
        console.log("zfJSBridge not found ," + apiName)
    }

    function on(eventName, callBack) {
        windowz.zfJSBridge ? windowz.zfJSBridge.on(eventName, function (ret) {
            callBack(ret)
        }) : defOn(eventName, callBack)
    }

    function defOn(eventName, callBack) {
        callBack.complete && callBack.complete()
        console.log("zfJSBridge not found ," + eventName)
    }

    var api = {
        setTitle: function (e) {
            call("setTitle", {
                title: e.title || ""
            }, e)
        }, closeWindow: function (e) {
            call("closeWindow", {
            }, e)
        }, putLocalStorageKV: function (e) {
            call("putLocalStorageKV", {
                key: e.key || "",
                value: e.value || ""
            }, e)
        }, getLocalStorageKV: function (e) {
            call("getLocalStorageKV", {
                key: e.key || ""
            }, e)
        }, gotoAliPay: function (e) {
            call("gotoAliPay", {
                parm: e.parm || ""
            }, e)
        },gotoHfAliPay: function (e) {
            call("gotoHfAliPay", {
                parm: e.parm || ""
            }, e)
        },gotoHfWxPay: function (e) {
            call("gotoHfWxPay", {
                parm: e.parm || ""
            }, e)
        },getAppToken: function (e) {
            call("getAppToken", {
            }, e)
        },queryRoute: function (e) {
            call("queryRoute", {
                parm: e.parm || ""
            }, e)
        },queryPickedDetail: function (e) {
            call("queryPickedDetail", {
                parm: e.parm || ""
            }, e)
        },shareTo: function(e) {
            call("shareTo", {
                parm: e.parm || ""
            }, e)
        },goToAliAuth: function(e) {
            call("goToAliAuth", {
                parm: e.parm || ""
            }, e)
        },getLocation: function (e) {
            call("getLocation", {
            }, e)
        },faceAuthentication: function (e) {
            call("faceAuthentication", {
                parm: e.parm || ""
            }, e)
        },getMetaInfo: function (e) {
            call("getMetaInfo", {
            }, e)
        },getYzHeadersInfo: function (e) {
            call("getYzHeadersInfo", {
            }, e)
        },callPhone: function(e) {
            call("callPhone", {
                parm: e.parm || ""
            }, e)
        },choosePicture: function (e) {
            call("choosePicture", {
		 parm: e.parm || ""
            }, e)
        },selectBlePrinter: function (e) {
            call("selectBlePrinter", {
            }, e)
        },selectCloudPrinter: function (e) {
            call("selectCloudPrinter", {
            }, e)
        },printWaybill: function(e) {
            call("printWaybill", {
                parm: e.parm || ""
            }, e)
        },sendAction: function(e) {
            call("sendAction", {
                parm: e.parm || ""
            },e)
        },jumpAppUrl: function(e) {
            call("jumpAppUrl", {
                parm: e.parm || ""
            },e)
        },getYzToken: function (e) {
            call("getYzToken", {
            }, e)
        },nativeCloseWindow: function (e) {
            on("nativeCloseWindow", e)
        },showPrinterStatus: function (e) {
            call("showPrinterStatus", {}, e)
        },scanBarcode: function (e) {
            call("scanBarcode", {}, e)
        },getClipboard : function (e) {
            call("getClipboard", {}, e)
        },upLoadParcelImage: function (e) {
            call("upLoadParcelImage", {
		 parm: e.parm || ""
            }, e)
        },setAlarm: function(e) {
            call("setAlarm", {
                parm: e.parm || ""
            },e)
        },saveImage: function(e) {
            call("saveImage", {
                parm: e.parm || ""
            },e)
        },speechRecognition : function (e) {
            call("speechRecognition", {}, e)
        },showLoading: function(e) {
            call("showLoading", {
                parm: e.parm || ""
            },e)
        },getContacts : function (e) {
            call("getContacts", {}, e)
        },sendSms: function(e) {
            call("sendSms", {
               parm: e.parm || ""
            },e)
        },smartCall: function(e) {
            call("smartCall", {
               parm: e.parm || ""
            },e)
        },refreshList: function (e) {
            on("refreshList", e)
        },oneClickDispatch: function(e) {
            call("oneClickDispatch", {
               parm: e.parm || ""
            },e)
        },transferToPost: function(e) {
            call("transferToPost", {
               parm: e.parm || ""
            },e)
        },getScanBarcode: function (e) {
            on("getScanBarcode", e)
        },showAddressDialog: function(e) {
            call("showAddressDialog", {
               parm: e.parm || ""
            },e)
        },printOrder: function(e) {
            call("printOrder", {
               parm: e.parm || ""
            },e)
        },getCuttedPly: function (e) {
            on("getCuttedPly", e)
        }
    }
    return open && (windowz.ytoH5Api = api), api
})